osg::ShaderComponent Class Reference

`#include <Shader>`

Inheritance diagram for osg::ShaderComponent:

## Public Member Functions

| ShaderComponent ()
| ShaderComponent (const ShaderComponent &sc, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Object (osg, ShaderComponent)
unsigned int | addShader (osg::Shader *shader)
void | removeShader (unsigned int i)
osg::Shader * | getShader (unsigned int i)
const osg::Shader * | getShader (unsigned int i) const
unsigned int | getNumShaders () const
virtual void | compileGLObjects (State &state) const
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (State *state=0) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef std::vector< osg::ref_ptr< osg::Shader > > | Shaders

## Protected Attributes

Shaders | _shaders
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Member Typedef Documentation

## Shaders

typedef std::vector< osg::ref_ptr<osg::Shader> > osg::ShaderComponent::Shaders

protected

## Constructor & Destructor Documentation

## ShaderComponent() [1/2]

osg::ShaderComponent::ShaderComponent | ( |  | ) |

Referenced by META_Object(), and ShaderComponent().

## ShaderComponent() [2/2]

osg::ShaderComponent::ShaderComponent | ( | const ShaderComponent & | sc,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

References ShaderComponent(), and osg::CopyOp::SHALLOW_COPY.

## Member Function Documentation

## addShader()

unsigned int osg::ShaderComponent::addShader | ( | osg::Shader * | shader | ) |

## compileGLObjects()

virtual void osg::ShaderComponent::compileGLObjects | ( | State & | state | ) | const

virtual

## getNumShaders()

unsigned int osg::ShaderComponent::getNumShaders | ( |  | ) | const

inline

References _shaders.

## getShader() [1/2]

osg::Shader * osg::ShaderComponent::getShader | ( | unsigned int | i | ) |

inline

References _shaders.

## getShader() [2/2]

const osg::Shader * osg::ShaderComponent::getShader | ( | unsigned int | i | ) | const

inline

References _shaders.

## META_Object()

osg::ShaderComponent::META_Object | ( | osg | ,
|  | ShaderComponent | )

References ShaderComponent().

## releaseGLObjects()

virtual void osg::ShaderComponent::releaseGLObjects | ( | State * | = 0 | ) | const

virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osg::Object.

## removeShader()

void osg::ShaderComponent::removeShader | ( | unsigned int | i | ) |

## resizeGLObjectBuffers()

virtual void osg::ShaderComponent::resizeGLObjectBuffers | ( | unsigned int |  | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::Object.

## Member Data Documentation

## _shaders

Shaders osg::ShaderComponent::_shaders

protected

Referenced by getNumShaders(), getShader(), and getShader().

The documentation for this class was generated from the following file:

- Shader